<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ObserverZooKeeperServer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">ObserverZooKeeperServer.java</span></div><h1>ObserverZooKeeperServer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.server.quorum;

import java.io.IOException;
import java.util.concurrent.ConcurrentLinkedQueue;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.server.FinalRequestProcessor;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.SyncRequestProcessor;
import org.apache.zookeeper.server.ZKDatabase;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;

/**
 * A ZooKeeperServer for the Observer node type. Not much is different, but
 * we anticipate specializing the request processors in the future. 
 *
 */
public class ObserverZooKeeperServer extends LearnerZooKeeperServer {
<span class="fc" id="L38">    private static final Logger LOG =</span>
<span class="fc" id="L39">        LoggerFactory.getLogger(ObserverZooKeeperServer.class);        </span>
    
    /**
     * Enable since request processor for writing txnlog to disk and
     * take periodic snapshot. Default is ON.
     */
    
<span class="fc" id="L46">    private boolean syncRequestProcessorEnabled = this.self.getSyncEnabled();</span>
    
    /*
     * Request processors
     */
    private CommitProcessor commitProcessor;
    private SyncRequestProcessor syncProcessor;
    
    /*
     * Pending sync requests
     */
<span class="fc" id="L57">    ConcurrentLinkedQueue&lt;Request&gt; pendingSyncs = </span>
        new ConcurrentLinkedQueue&lt;Request&gt;();
        
    ObserverZooKeeperServer(FileTxnSnapLog logFactory, QuorumPeer self,
            DataTreeBuilder treeBuilder, ZKDatabase zkDb) throws IOException {
<span class="fc" id="L62">        super(logFactory, self.tickTime, self.minSessionTimeout,</span>
                self.maxSessionTimeout, treeBuilder, zkDb, self);
<span class="fc" id="L64">        LOG.info(&quot;syncEnabled =&quot; + syncRequestProcessorEnabled);</span>
<span class="fc" id="L65">    }</span>
    
    public Observer getObserver() {
<span class="fc" id="L68">        return self.observer;</span>
    }
    
    @Override
    public Learner getLearner() {
<span class="fc" id="L73">        return self.observer;</span>
    }       
    
    /**
     * Unlike a Follower, which sees a full request only during the PROPOSAL
     * phase, Observers get all the data required with the INFORM packet. 
     * This method commits a request that has been unpacked by from an INFORM
     * received from the Leader. 
     *      
     * @param request
     */
    public void commitRequest(Request request) {     
<span class="pc bpc" id="L85" title="1 of 2 branches missed.">        if (syncRequestProcessorEnabled) {</span>
            // Write to txnlog and take periodic snapshot
<span class="fc" id="L87">            syncProcessor.processRequest(request);</span>
        }
<span class="fc" id="L89">        commitProcessor.commit(request);        </span>
<span class="fc" id="L90">    }</span>
    
    /**
     * Set up the request processors for an Observer:
     * firstProcesor-&gt;commitProcessor-&gt;finalProcessor
     */
    @Override
    protected void setupRequestProcessors() {      
        // We might consider changing the processor behaviour of 
        // Observers to, for example, remove the disk sync requirements.
        // Currently, they behave almost exactly the same as followers.
<span class="fc" id="L101">        RequestProcessor finalProcessor = new FinalRequestProcessor(this);</span>
<span class="fc" id="L102">        commitProcessor = new CommitProcessor(finalProcessor,</span>
<span class="fc" id="L103">                Long.toString(getServerId()), true,</span>
<span class="fc" id="L104">                getZooKeeperServerListener());</span>
<span class="fc" id="L105">        commitProcessor.start();</span>
<span class="fc" id="L106">        firstProcessor = new ObserverRequestProcessor(this, commitProcessor);</span>
<span class="fc" id="L107">        ((ObserverRequestProcessor) firstProcessor).start();</span>

        /*
         * Observer should write to disk, so that the it won't request
         * too old txn from the leader which may lead to getting an entire
         * snapshot.
         *
         * However, this may degrade performance as it has to write to disk
         * and do periodic snapshot which may double the memory requirements
         */
<span class="pc bpc" id="L117" title="1 of 2 branches missed.">        if (syncRequestProcessorEnabled) {</span>
<span class="fc" id="L118">            syncProcessor = new SyncRequestProcessor(this, null);</span>
<span class="fc" id="L119">            syncProcessor.start();</span>
        }
<span class="fc" id="L121">    }</span>

    /*
     * Process a sync request
     */
    synchronized public void sync(){
<span class="pc bpc" id="L127" title="1 of 2 branches missed.">        if(pendingSyncs.size() ==0){</span>
<span class="nc" id="L128">            LOG.warn(&quot;Not expecting a sync.&quot;);</span>
<span class="nc" id="L129">            return;</span>
        }
                
<span class="fc" id="L132">        Request r = pendingSyncs.remove();</span>
<span class="fc" id="L133">        commitProcessor.commit(r);</span>
<span class="fc" id="L134">    }</span>
    
    @Override
    public String getState() {
<span class="fc" id="L138">        return &quot;observer&quot;;</span>
    };    

    @Override
    public synchronized void shutdown() {
<span class="fc bfc" id="L143" title="All 2 branches covered.">        if (!isRunning()) {</span>
<span class="fc" id="L144">            LOG.debug(&quot;ZooKeeper server is not running, so not proceeding to shutdown!&quot;);</span>
<span class="fc" id="L145">            return;</span>
        }
<span class="fc" id="L147">        super.shutdown();</span>
<span class="pc bpc" id="L148" title="2 of 4 branches missed.">        if (syncRequestProcessorEnabled &amp;&amp; syncProcessor != null) {</span>
<span class="fc" id="L149">            syncProcessor.shutdown();</span>
        }
<span class="fc" id="L151">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>